
# SEEDPoisoner

Welcome to SEEDPoisoner, a pivotal component of the SEEDGuard.AI initiative. This project is dedicated to enhancing the security and integrity of data for AI models and corresponding datasets in software engineering.

## Project Overview

[//]: # (![img.png]&#40;images/seedpoisoner.png&#41;)
SEEDPoisoner is an open-source effort under the broader umbrella of SEEDGuard.AI, aimed at revolutionizing AI for Software Engineering with a keen focus on data security. Our mission is to safeguard AI models against data poisoning and backdoor threats, ensuring the development of trustworthy AI systems.

<div align="center">
   <img src="images/seedpoisoner.png" width="30%" height="60%">
</div>


### Key Features

- **Robust Security**: Implementation of robust defenses against poison attacks and backdooring threats to datasets.
- **Scalable Infrastructure**: Development of a scalable system infrastructure to support the growing needs of the AI for SE/Code domain.


### Research Goals

1. **Enhancing System Fault Tolerance**: Focusing on data security to protect datasets from poison attacks and ensure the integrity of the data.
2. **Optimizing Model Performance**: Implementing retraining protocols to enhance the resilience of SEEDGuard against adversarial attacks.
3. **User-Friendly Functionality**: Ensuring that the project's infrastructure and APIs are aligned with the objectives of SEEDGuard.AI, facilitating easy access and interaction for researchers and developers.

## Getting Started

To contribute to SEEDPoisoner or use it in your projects, please follow these steps:

1. Clone the repository:
   ```
   git clone https://github.com/NCSU/SEEDPoisoner.git
   ```
2. Install the required dependencies:
   ```
   pip3 install -r requirements.txt
   ```
3. Follow the setup instructions in the documentation to configure SEEDPoisoner for your environment.

4. To package the source code as a PyPI library:
   ```
   pip3 install setuptools
   python3 setup.py sdist bdist_wheel
   
   ```

## Contributing

SEEDPoisoner thrives on community contributions. Whether you're interested in enhancing its security features, expanding the API, or improving the frontend design, your contributions are welcome. Please refer to our contribution guideline at CONTRIBUTING.md for more information on how to contribute.



## Contact

For more information, support, or to contribute to SEEDPoisoner, please contact us at [SEEDGuard.AI Contact Information].

---

